#pragma once

#include <string>
#include "lua.hpp"

using namespace std;

extern lua_State* L;
extern int lua_State_Err;

// lua_State̎擾
__declspec(dllexport) lua_State* luaL_getstate(void);

// lua_StateAŏ̃t@Csɉ炩̃G[ԂɂȂǂ̃tOBTSModŁAG[ɂȂĂȂƂOƂďi߂邽߁B
__declspec(dllexport) int luaL_getstate_err(void);


void lua_OutputDebugStream( const char *format, ... );

// luaC^v^[h
void LoadLuaInterpreter();
// luaC^v^
void FreeLuaInterpreter();

// luãX^bÑ_v
void lua_DumpStack(lua_State* L);

// error\ăC^v^exitB
void lua_error_and_exit(lua_State *L, const char *fmt, ...);


// w̖Őe[uLuaɃvbV
int PushEmptyTable(lua_State *L, char *szTableName);

// lua_getglobal̐l^Cṽbp[
double lua_getglobal_numtype(char *var_name);

// lua_getglobal̕^Cṽbp[
string lua_getglobal_strtype(char *var_name);

// lua_getfield̐l^Cṽbp[
int lua_getfield_numtype(lua_State *L, const char *key);

// lua_getfield̕^Cṽbp[
string lua_getfield_strtype(lua_State *L, const char *key);

// printf`Ɠľ`ŁAlua̋Lqs邱ƂłB
int lua_DoStringFormat( const char *format, ... );

